/* TroiaPreview
 * version 0.4 date 2004-09-20
 * Copyright (C) 2003-2004 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#include <stdio.h>
#include <time.h>
#include <string.h>

#include "Log.h"

//global variables
FILE * LogFile = NULL;

//start logging into log file
void LogStart( char * FileName )
{
  if( LogFile != NULL )
    fclose( LogFile );
  LogFile = NULL;
  if( FileName != NULL && FileName[0] != 0 )
    LogFile = fopen( FileName, "wt" );
}

//write a line to the logfile
void Log( char * Info, char * Text )
{
  //local variables
  time_t Time;
  struct tm LocalTime;
  char Timestamp[64];

  //logfile not open, no info or no text
  if( LogFile == NULL || Info[0] == 0 || Text[0] == 0 )
    return;

  //write timestamp
  Time = time( NULL );
  LocalTime = *localtime( &Time ); 
  sprintf( Timestamp, "%04d-%02d-%02d %02d:%02d:%02d ",
    LocalTime.tm_year, LocalTime.tm_mon, LocalTime.tm_mday, LocalTime.tm_hour, LocalTime.tm_min, LocalTime.tm_sec );
  fwrite( Timestamp, sizeof( char ), strlen( Timestamp ), LogFile );

  //write Info
  fwrite( Info, sizeof( char ), strlen( Info ), LogFile );

  //write seperator
  fwrite( ": ", sizeof( char ), 2, LogFile );

  //write Text
  fwrite( Text, sizeof( char ), strlen( Text ), LogFile );

  //write newline
  fwrite( "\n", sizeof( char ), 1, LogFile );
}

//stop logging
void LogStop( )
{
  if( LogFile != NULL )
    fclose( LogFile );
  LogFile = NULL;
}

